Attribute VB_Name = "Interface"
'  +------------------------------------------------------------------+
'  | Dieses Modul enthlt fertige Codes fr die folgenden Nibblemodul-|
'  | typen fr das modulare COM-Interface:                            |
'  | -Siebensegment mit 7447   = Anz7 Ziffer, Port                    |
'  | -Plus/Minus-Anzeige (1.) = AnzPM Plus, Minus, Eins, Punkt, Port |
'  | -LEDs/Low-aktive Ausgnge = LED1 Nibble, Port '(LSB = LED1)      |
'  |                             LED2 LED1, LED2, LED3, LED4, Port    |
'  | -High-aktive Ausg./Trans. = AUS1 Nibble, Port '(LSB = A1)        |
'  |                             AUS2 A1, A2, A3, A4, Port            |
'  +------------------------------------------------------------------+
'  | Fr die Aufbauanleitung des Interfaces und der Nibble-Module     |
'  | sowie fr Software-Updates siehe http://www.elektronik.de.vu     |
'  +------------------------------------------------------------------+
'  |    are 2002  -  http://www.elektronik.de.vu  -  VB6 Quellcode   |
'  +------------------------------------------------------------------+

'Die Codes fr die Nibblemodule mssen immer in der richtigen Reihen-
'folge und immer vollstndig aufgerufen werden. Zuwerst kommt das Modul
'fr das Nibble am Ende der Schieberegisterkette!
'Beispiel: ein +/- Modul, ein 7-Segment-Modul und 2 LED-Module:
'LED1 7, &H3FC                         'Schaltet LED 1,2,3 ein (7=0111)
'LED2 True, False, True, False, &H3FC  'Schaltet LED 1 und 3 ein
'Anz7 5, &H3FC                         'Zeigt eine 5 an
'AnzPM True, False, False, True, &H3FC 'Zeigt + und den Punkt an


'######################################################################


'Definitionen aus der Port.dll (http://www.bkainka.de)
Declare Function OPENCOM Lib "Port" (ByVal A$) As Integer
Declare Sub CLOSECOM Lib "Port" ()
Declare Sub DTR Lib "Port" (ByVal b%)
Declare Sub RTS Lib "Port" (ByVal b%)
Declare Sub TXD Lib "Port" (ByVal b%)
Declare Function CTS Lib "Port" () As Integer
Declare Function DSR Lib "Port" () As Integer
Declare Function RI Lib "Port" () As Integer
Declare Function DCD Lib "Port" () As Integer

Sub COMOpen(Port As String)
'ffnet eine COM-Schnittstelle
  If Port > 4 Or Port < 1 Then MsgBox "Error: Die Schnittstelle muss 1-4 sein!", , "COMOpen  are 2002"
  A = OPENCOM("COM" + Port + ",1200,N,8,1")
  If A = 0 Then
    MsgBox "Error: ffnen von COM" + Port + " fehlgeschlagen. | Port existiert nicht oder wird benutzt." + Chr$(13) + "Error: Unable to open COM" + Port + ". | Port doesn't exist or is in use." + Chr$(13) + "ERROR CODE: " + CStr(A), , "COM" + Port + " failure!"
    Form1.Senden_Anz7.Enabled = False
    Form1.Senden_AnzPM.Enabled = False
    Form1.Senden_LED.Enabled = False
    Form1.Senden_AUS.Enabled = False
    Form1.COMAnz.Caption = "COM" + Port + " failure! " + CStr(A)
  Else
    Form1.Senden_Anz7.Enabled = True
    Form1.Senden_AnzPM.Enabled = True
    Form1.Senden_LED.Enabled = True
    Form1.Senden_AUS.Enabled = True
    Form1.COMAnz.Caption = "Ready. COM" + Port + " " + CStr(A) + " OK"
  End If
End Sub

Sub Anz7(Ziffer As Byte, Port As Integer)
'fr ein Siebensegment-Nibblemodul mit 7447
'Ziffer 10 bedeutet aus (nicht bei 6/9-Korrektur!)
  If Ziffer > 10 Then MsgBox "Error: Die Zahl muss im Bereich 0...10 sein (10=aus)!", , "Anz7  are 2002"
  If Ziffer = 10 Then Ziffer = 15
  Schiebe Ziffer And 1, Port
  Schiebe (Ziffer And 2) / 2, Port
  Schiebe (Ziffer And 4) / 4, Port
  Schiebe (Ziffer And 8) / 8, Port
End Sub

Sub AnzPM(Plus As Boolean, Minus As Boolean, Eins As Boolean, Punkt As Boolean, Port As Integer)
'fr ein Nibblemodul mit Plus/Minus Anzeige
  Schiebe Plus, Port
  If Minus = True Or Plus = True Then
    Schiebe True, Port
  Else
    Schiebe False, Port
  End If
  Schiebe Eins, Port
  Schiebe Punkt, Port
End Sub

Sub LED1(LEDs As Byte, Port As Integer)
'fr ein Nibblemodul mit LEDs/Low-aktiven Ausgngen
'akzeptiert 0000-1111 (0-15) zur Ansteuerung
'Das LSB entspricht LED1
  If LEDs > 15 Then MsgBox "Error: Die Zahl muss im Bereich binr 0000-1111 sein (dezimal 0-15)!", , "LED1  are 2002"
  Schiebe Not (LEDs And 1), Port
  Schiebe Not ((LEDs And 2) / 2), Port
  Schiebe Not ((LEDs And 4) / 4), Port
  Schiebe Not ((LEDs And 8) / 8), Port
End Sub

Sub LED2(LED1 As Boolean, LED2 As Boolean, LED3 As Boolean, LED4 As Boolean, Port As Integer)
'fr ein Nibblemodul mit LEDs/Low-aktiven Ausgngen
'akzeptiert je LED eine eigene Variable.
  Schiebe Not LED1, Port
  Schiebe Not LED2, Port
  Schiebe Not LED3, Port
  Schiebe Not LED4, Port
End Sub

Sub AUS1(Nibble As Byte, Port As Integer)
'fr ein Nibblemodul mit High-aktiven Ausgngen/Transistoren
'akzeptiert 0000-1111 (0-15) zur Ansteuerung
'Das LSB entspricht A1
  If Nibble > 15 Then MsgBox "Error: Die Zahl muss im Bereich binr 0000-1111 sein (dezimal 0-15)!", , "AUS1  are 2002"
  Schiebe Nibble And 1, Port
  Schiebe (LEDs And 2) / 2, Port
  Schiebe (LEDs And 4) / 4, Port
  Schiebe (LEDs And 8) / 8, Port
End Sub

Sub AUS2(A1 As Boolean, A2 As Boolean, A3 As Boolean, A4 As Boolean, Port As Integer)
'fr ein Nibblemodul mit High-aktiven Ausgngen/Transistoren
'akzeptiert jeden Ausgang eine eigene Variable.
  Schiebe A1, Port
  Schiebe A2, Port
  Schiebe A3, Port
  Schiebe A4, Port
End Sub

Sub Schiebe(Bit As Boolean, Port As Integer)
'zum Schieben eines Bits (True=1, False=0)
  If Port = 0 Then MsgBox "Error: Der Port kann nicht null sein.", , "Schiebe  are 2002"
  If Bit Then
    DTR 1
    RTS 0
    DTR 0
  Else
    DTR 1
    RTS 1
    DTR 0
  End If
End Sub
